diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/wifi-tx-vector.h ns-3.44/src/wifi/model/wifi-tx-vector.h
--- ns-3.43/src/wifi/model/wifi-tx-vector.h	2024-10-09 16:41:10.132656800 -0700
+++ ns-3.44/src/wifi/model/wifi-tx-vector.h	2025-03-09 16:55:49.803372600 -0700
@@ -38,24 +38,24 @@
     /**
      * Compare this user info to the given user info.
      *
-     * \param other the given user info
-     * \return true if this user info compares equal to the given user info, false otherwise
+     * @param other the given user info
+     * @return true if this user info compares equal to the given user info, false otherwise
      */
     bool operator==(const HeMuUserInfo& other) const;
     /**
      * Compare this user info to the given user info.
      *
-     * \param other the given user info
-     * \return true if this user info differs from the given user info, false otherwise
+     * @param other the given user info
+     * @return true if this user info differs from the given user info, false otherwise
      */
     bool operator!=(const HeMuUserInfo& other) const;
 };
 
-/// 8 bit RU_ALLOCATION per 20 MHz
-using RuAllocation = std::vector<uint8_t>;
+/// 9 bits RU_ALLOCATION per 20 MHz
+using RuAllocation = std::vector<uint16_t>;
 
 /**
- * \ingroup wifi
+ * @ingroup wifi
  * Enum for the different values for CENTER_26_TONE_RU
  */
 enum Center26ToneRuIndication : uint8_t
@@ -88,7 +88,7 @@
  * still needs to initialize at least the mode and transmit power level
  * appropriately.
  *
- * \note the above reference is valid for the DSSS PHY only (clause
+ * @note the above reference is valid for the DSSS PHY only (clause
  * 16). TXVECTOR is defined also for the other PHYs, however they
  * don't include the TXPWRLVL explicitly in the TXVECTOR. This is
  * somewhat strange, since all PHYs actually have a
@@ -108,20 +108,20 @@
     /**
      * Create a TXVECTOR with the given parameters.
      *
-     * \param mode WifiMode
-     * \param powerLevel transmission power level
-     * \param preamble preamble type
-     * \param guardInterval the guard interval duration in nanoseconds
-     * \param nTx the number of TX antennas
-     * \param nss the number of spatial STBC streams (NSS)
-     * \param ness the number of extension spatial streams (NESS)
-     * \param channelWidth the channel width
-     * \param aggregation enable or disable MPDU aggregation
-     * \param stbc enable or disable STBC
-     * \param ldpc enable or disable LDPC (BCC is used otherwise)
-     * \param bssColor the BSS color
-     * \param length the LENGTH field of the L-SIG
-     * \param triggerResponding the Trigger Responding parameter
+     * @param mode WifiMode
+     * @param powerLevel transmission power level
+     * @param preamble preamble type
+     * @param guardInterval the guard interval duration in nanoseconds
+     * @param nTx the number of TX antennas
+     * @param nss the number of spatial STBC streams (NSS)
+     * @param ness the number of extension spatial streams (NESS)
+     * @param channelWidth the channel width
+     * @param aggregation enable or disable MPDU aggregation
+     * @param stbc enable or disable STBC
+     * @param ldpc enable or disable LDPC (BCC is used otherwise)
+     * @param bssColor the BSS color
+     * @param length the LENGTH field of the L-SIG
+     * @param triggerResponding the Trigger Responding parameter
      */
     WifiTxVector(WifiMode mode,
                  uint8_t powerLevel,
@@ -139,12 +139,12 @@
                  bool triggerResponding = false);
     /**
      * Copy constructor
-     * \param txVector the TXVECTOR to copy
+     * @param txVector the TXVECTOR to copy
      */
     WifiTxVector(const WifiTxVector& txVector);
 
     /**
-     * \returns whether mode has been initialized
+     * @returns whether mode has been initialized
      */
     bool GetModeInitialized() const;
     /**
@@ -153,79 +153,79 @@
      * MU PPDU, return the transmission mode (MCS) selected for the transmission
      * to the station identified by the given STA-ID.
      *
-     * \param staId the station ID for MU
-     * \returns the selected payload transmission mode
+     * @param staId the station ID for MU
+     * @returns the selected payload transmission mode
      */
     WifiMode GetMode(uint16_t staId = SU_STA_ID) const;
     /**
      * Sets the selected payload transmission mode
      *
-     * \param mode the payload WifiMode
+     * @param mode the payload WifiMode
      */
     void SetMode(WifiMode mode);
     /**
      * Sets the selected payload transmission mode for a given STA ID (for MU only)
      *
-     * \param mode
-     * \param staId the station ID for MU
+     * @param mode
+     * @param staId the station ID for MU
      */
     void SetMode(WifiMode mode, uint16_t staId);
 
     /**
      * Get the modulation class specified by this TXVECTOR.
      *
-     * \return the Modulation Class specified by this TXVECTOR
+     * @return the Modulation Class specified by this TXVECTOR
      */
     WifiModulationClass GetModulationClass() const;
 
     /**
-     * \returns the transmission power level
+     * @returns the transmission power level
      */
     uint8_t GetTxPowerLevel() const;
     /**
      * Sets the selected transmission power level
      *
-     * \param powerlevel the transmission power level
+     * @param powerlevel the transmission power level
      */
     void SetTxPowerLevel(uint8_t powerlevel);
     /**
-     * \returns the preamble type
+     * @returns the preamble type
      */
     WifiPreamble GetPreambleType() const;
     /**
      * Sets the preamble type
      *
-     * \param preamble the preamble type
+     * @param preamble the preamble type
      */
     void SetPreambleType(WifiPreamble preamble);
     /**
-     * \returns the channel width
+     * @returns the channel width
      */
     MHz_u GetChannelWidth() const;
     /**
      * Sets the selected channelWidth
      *
-     * \param channelWidth the channel width
+     * @param channelWidth the channel width
      */
     void SetChannelWidth(MHz_u channelWidth);
     /**
-     * \returns the guard interval duration (in nanoseconds)
+     * @returns the guard interval duration (in nanoseconds)
      */
     Time GetGuardInterval() const;
     /**
      * Sets the guard interval duration (in nanoseconds)
      *
-     * \param guardInterval the guard interval duration (in nanoseconds)
+     * @param guardInterval the guard interval duration (in nanoseconds)
      */
     void SetGuardInterval(Time guardInterval);
     /**
-     * \returns the number of TX antennas
+     * @returns the number of TX antennas
      */
     uint8_t GetNTx() const;
     /**
      * Sets the number of TX antennas
      *
-     * \param nTx the number of TX antennas
+     * @param nTx the number of TX antennas
      */
     void SetNTx(uint8_t nTx);
     /**
@@ -234,113 +234,113 @@
      * return the number of spatial streams for the transmission to the station
      * identified by the given STA-ID.
      *
-     * \param staId the station ID for MU
-     * \returns the number of spatial streams
+     * @param staId the station ID for MU
+     * @returns the number of spatial streams
      */
     uint8_t GetNss(uint16_t staId = SU_STA_ID) const;
     /**
-     * \returns the maximum number of Nss over all RUs of an HE MU (used for OFDMA)
+     * @returns the maximum number of Nss over all RUs of an HE MU (used for OFDMA)
      */
     uint8_t GetNssMax() const;
     /**
-     * \returns the total number of Nss for a given RU of an HE MU (used for full bandwidth MU-MIMO)
+     * @returns the total number of Nss for a given RU of an HE MU (used for full bandwidth MU-MIMO)
      */
     uint8_t GetNssTotal() const;
     /**
      * Sets the number of Nss
      *
-     * \param nss the number of spatial streams
+     * @param nss the number of spatial streams
      */
     void SetNss(uint8_t nss);
     /**
      * Sets the number of Nss for MU
      *
-     * \param nss the number of spatial streams
-     * \param staId the station ID for MU
+     * @param nss the number of spatial streams
+     * @param staId the station ID for MU
      */
     void SetNss(uint8_t nss, uint16_t staId);
     /**
-     * \returns the number of extended spatial streams
+     * @returns the number of extended spatial streams
      */
     uint8_t GetNess() const;
     /**
      * Sets the Ness number
      *
-     * \param ness the number of extended spatial streams
+     * @param ness the number of extended spatial streams
      */
     void SetNess(uint8_t ness);
     /**
      * Checks whether the PSDU contains A-MPDU.
-     * \returns true if this PSDU has A-MPDU aggregation,
+     * @returns true if this PSDU has A-MPDU aggregation,
      *          false otherwise
      */
     bool IsAggregation() const;
     /**
      * Sets if PSDU contains A-MPDU.
      *
-     * \param aggregation whether the PSDU contains A-MPDU or not
+     * @param aggregation whether the PSDU contains A-MPDU or not
      */
     void SetAggregation(bool aggregation);
     /**
      * Check if STBC is used or not
      *
-     * \returns true if STBC is used,
+     * @returns true if STBC is used,
      *           false otherwise
      */
     bool IsStbc() const;
     /**
      * Sets if STBC is being used
      *
-     * \param stbc enable or disable STBC
+     * @param stbc enable or disable STBC
      */
     void SetStbc(bool stbc);
     /**
      * Check if LDPC FEC coding is used or not
      *
-     * \returns true if LDPC is used,
+     * @returns true if LDPC is used,
      *          false if BCC is used
      */
     bool IsLdpc() const;
     /**
      * Sets if LDPC FEC coding is being used
      *
-     * \param ldpc enable or disable LDPC
+     * @param ldpc enable or disable LDPC
      */
     void SetLdpc(bool ldpc);
     /**
      * Checks whether this TXVECTOR corresponds to a non-HT duplicate.
-     * \returns true if this TXVECTOR corresponds to a non-HT duplicate,
+     * @returns true if this TXVECTOR corresponds to a non-HT duplicate,
      *          false otherwise.
      */
     bool IsNonHtDuplicate() const;
     /**
      * Set the BSS color
-     * \param color the BSS color
+     * @param color the BSS color
      */
     void SetBssColor(uint8_t color);
     /**
      * Get the BSS color
-     * \return the BSS color
+     * @return the BSS color
      */
     uint8_t GetBssColor() const;
     /**
      * Set the LENGTH field of the L-SIG
-     * \param length the LENGTH field of the L-SIG
+     * @param length the LENGTH field of the L-SIG
      */
     void SetLength(uint16_t length);
     /**
      * Get the LENGTH field of the L-SIG
-     * \return the LENGTH field of the L-SIG
+     * @return the LENGTH field of the L-SIG
      */
     uint16_t GetLength() const;
     /**
      * Return true if the Trigger Responding parameter is set to true, false otherwise.
-     * \return true if the Trigger Responding parameter is set to true, false otherwise
+     * @return true if the Trigger Responding parameter is set to true, false otherwise
      */
     bool IsTriggerResponding() const;
     /**
      * Set the Trigger Responding parameter to the given value
-     * \param triggerResponding the value for the Trigger Responding parameter
+     * @param triggerResponding the value for the Trigger Responding parameter
      */
     void SetTriggerResponding(bool triggerResponding);
     /**
@@ -350,86 +350,86 @@
      * If a PHY band is specified, it is checked that the PHY band is appropriate for
      * the modulation class of the TXVECTOR, in case the latter is OFDM or ERP-OFDM.
      *
-     * \param band the PHY band
-     * \return true if the WifiTxVector parameters are allowed by the standard
+     * @param band the PHY band
+     * @return true if the WifiTxVector parameters are allowed by the standard
      */
     bool IsValid(WifiPhyBand band = WIFI_PHY_BAND_UNSPECIFIED) const;
     /**
-     * \return true if this TX vector is used for a multi-user (OFDMA and/or MU-MIMO) transmission
+     * @return true if this TX vector is used for a multi-user (OFDMA and/or MU-MIMO) transmission
      */
     bool IsMu() const;
     /**
-     * \return true if this TX vector is used for a downlink multi-user (OFDMA and/or MU-MIMO)
+     * @return true if this TX vector is used for a downlink multi-user (OFDMA and/or MU-MIMO)
      * transmission
      */
     bool IsDlMu() const;
     /**
-     * \return true if this TX vector is used for an uplink multi-user (OFDMA and/or MU-MIMO)
+     * @return true if this TX vector is used for an uplink multi-user (OFDMA and/or MU-MIMO)
      * transmission
      */
     bool IsUlMu() const;
     /**
      * Return true if this TX vector is used for a downlink multi-user transmission using OFDMA.
      *
-     * \return true if this TX vector is used for a downlink multi-user transmission using OFDMA
+     * @return true if this TX vector is used for a downlink multi-user transmission using OFDMA
      */
     bool IsDlOfdma() const;
     /**
      * Return true if this TX vector is used for a downlink multi-user transmission using MU-MIMO.
      *
-     * \return true if this TX vector is used for a downlink multi-user transmission using MU-MIMO
+     * @return true if this TX vector is used for a downlink multi-user transmission using MU-MIMO
      */
     bool IsDlMuMimo() const;
     /**
      * Check if STA ID is allocated
-     * \param staId STA ID
-     * \return true if allocated, false otherwise
+     * @param staId STA ID
+     * @return true if allocated, false otherwise
      */
     bool IsAllocated(uint16_t staId) const;
     /**
      * Get the RU specification for the STA-ID.
      * This is applicable only for MU.
      *
-     * \param staId the station ID
-     * \return the RU specification for the STA-ID
+     * @param staId the station ID
+     * @return the RU specification for the STA-ID
      */
     HeRu::RuSpec GetRu(uint16_t staId) const;
     /**
      * Set the RU specification for the STA-ID.
      * This is applicable only for MU.
      *
-     * \param ru the RU specification
-     * \param staId the station ID
+     * @param ru the RU specification
+     * @param staId the station ID
      */
     void SetRu(HeRu::RuSpec ru, uint16_t staId);
     /**
      * Get the HE MU user-specific transmission information for the given STA-ID.
      * This is applicable only for HE MU.
      *
-     * \param staId the station ID
-     * \return the HE MU user-specific transmission information for the given STA-ID
+     * @param staId the station ID
+     * @return the HE MU user-specific transmission information for the given STA-ID
      */
     HeMuUserInfo GetHeMuUserInfo(uint16_t staId) const;
     /**
      * Set the HE MU user-specific transmission information for the given STA-ID.
      * This is applicable only for HE MU.
      *
-     * \param staId the station ID
-     * \param userInfo the HE MU user-specific transmission information
+     * @param staId the station ID
+     * @param userInfo the HE MU user-specific transmission information
      */
     void SetHeMuUserInfo(uint16_t staId, HeMuUserInfo userInfo);
     /**
      * Get a const reference to the map HE MU user-specific transmission information indexed by
      * STA-ID. This is applicable only for HE MU.
      *
-     * \return a const reference to the map of HE MU user-specific information indexed by STA-ID
+     * @return a const reference to the map of HE MU user-specific information indexed by STA-ID
      */
     const HeMuUserInfoMap& GetHeMuUserInfoMap() const;
     /**
      * Get a reference to the map HE MU user-specific transmission information indexed by STA-ID.
      * This is applicable only for HE MU.
      *
-     * \return a reference to the map of HE MU user-specific information indexed by STA-ID
+     * @return a reference to the map of HE MU user-specific information indexed by STA-ID
      */
     HeMuUserInfoMap& GetHeMuUserInfoMap();
 
@@ -439,22 +439,22 @@
     /**
      * Get the map of specific user info parameters ordered per increasing frequency RUs.
      *
-     * \param p20Index the index of the primary20 channel
-     * \return the map of specific user info parameters ordered per increasing frequency RUs
+     * @param p20Index the index of the primary20 channel
+     * @return the map of specific user info parameters ordered per increasing frequency RUs
      */
     UserInfoMapOrderedByRus GetUserInfoMapOrderedByRus(uint8_t p20Index) const;
 
     /**
      * Indicate whether the Common field is present in the HE-SIG-B field.
      *
-     * \return true if the Common field is present in the HE-SIG-B, false otherwise
+     * @return true if the Common field is present in the HE-SIG-B, false otherwise
      */
     bool IsSigBCompression() const;
 
     /**
      * Set the 20 MHz subchannels that are punctured.
      *
-     * \param inactiveSubchannels the bitmap indexed by the 20 MHz subchannels in ascending order,
+     * @param inactiveSubchannels the bitmap indexed by the 20 MHz subchannels in ascending order,
      *        where each bit indicates whether the corresponding 20 MHz subchannel is punctured or
      * not within the transmission bandwidth
      */
@@ -462,7 +462,7 @@
     /**
      * Get the 20 MHz subchannels that are punctured.
      *
-     * \return the bitmap indexed by the 20 MHz subchannels in ascending order,
+     * @return the bitmap indexed by the 20 MHz subchannels in ascending order,
      *         where each bit indicates whether the corresponding 20 MHz subchannel is punctured or
      * not within the transmission bandwidth
      */
@@ -470,33 +470,33 @@
 
     /**
      * Set the MCS used for SIG-B
-     * \param mode MCS used for SIG-B
+     * @param mode MCS used for SIG-B
      */
     void SetSigBMode(const WifiMode& mode);
 
     /**
      * Get MCS used for SIG-B
-     * \return MCS for SIG-B
+     * @return MCS for SIG-B
      */
     WifiMode GetSigBMode() const;
 
     /**
      * Set RU_ALLOCATION field
-     * \param ruAlloc 8 bit RU_ALLOCATION per 20 MHz
-     * \param p20Index the index of the primary20 channel
+     * @param ruAlloc 8 bit RU_ALLOCATION per 20 MHz
+     * @param p20Index the index of the primary20 channel
      */
     void SetRuAllocation(const RuAllocation& ruAlloc, uint8_t p20Index);
 
     /**
      * Get RU_ALLOCATION field
-     * \return 8 bit RU_ALLOCATION per 20 MHz
-     * \param p20Index the index of the primary20 channel
+     * @return 8 bit RU_ALLOCATION per 20 MHz
+     * @param p20Index the index of the primary20 channel
      */
     const RuAllocation& GetRuAllocation(uint8_t p20Index) const;
 
     /**
      * Set CENTER_26_TONE_RU field
-     * \param center26ToneRuIndication the CENTER_26_TONE_RU field
+     * @param center26ToneRuIndication the CENTER_26_TONE_RU field
      */
     void SetCenter26ToneRuIndication(Center26ToneRuIndication center26ToneRuIndication);
 
@@ -504,18 +504,18 @@
      * Get CENTER_26_TONE_RU field
      * This field is present if format is HE_MU and
      * when channel width is set to 80 MHz or larger.
-     * \return the CENTER_26_TONE_RU field if present
+     * @return the CENTER_26_TONE_RU field if present
      */
     std::optional<Center26ToneRuIndication> GetCenter26ToneRuIndication() const;
 
     /**
      * Set the EHT_PPDU_TYPE parameter
-     * \param type the EHT_PPDU_TYPE parameter
+     * @param type the EHT_PPDU_TYPE parameter
      */
     void SetEhtPpduType(uint8_t type);
     /**
      * Get the EHT_PPDU_TYPE parameter
-     * \return the EHT_PPDU_TYPE parameter
+     * @return the EHT_PPDU_TYPE parameter
      */
     uint8_t GetEhtPpduType() const;
 
@@ -526,8 +526,8 @@
      * based on the content of per-user information.
      * This is valid only for allocations of RUs of the same size per 20 MHz subchannel.
      *
-     * \param p20Index the index of the primary20 channel
-     * \return 8 bit RU_ALLOCATION per 20 MHz
+     * @param p20Index the index of the primary20 channel
+     * @return 8 bit RU_ALLOCATION per 20 MHz
      */
     RuAllocation DeriveRuAllocation(uint8_t p20Index) const;
 
@@ -536,15 +536,15 @@
      * for which its CENTER_26_TONE_RU has not been set yet,
      * based on the content of per-user information.
      *
-     * \return the CENTER_26_TONE_RU field
+     * @return the CENTER_26_TONE_RU field
      */
     Center26ToneRuIndication DeriveCenter26ToneRuIndication() const;
 
     /**
      * Get the number of STAs in a given RU.
      *
-     * \param ru the RU specification
-     * \return the number of STAs in the RU
+     * @param ru the RU specification
+     * @return the number of STAs in the RU
      */
     uint8_t GetNumStasInRu(const HeRu::RuSpec& ru) const;
 
@@ -593,10 +593,10 @@
 /**
  * Serialize WifiTxVector to the given ostream.
  *
- * \param os the output stream
- * \param v the WifiTxVector to stringify
+ * @param os the output stream
+ * @param v the WifiTxVector to stringify
  *
- * \return output stream
+ * @return output stream
  */
 std::ostream& operator<<(std::ostream& os, const WifiTxVector& v);
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/wifi-types.h ns-3.44/src/wifi/model/wifi-types.h
--- ns-3.43/src/wifi/model/wifi-types.h	2024-10-09 16:41:10.132656800 -0700
+++ ns-3.44/src/wifi/model/wifi-types.h	2025-03-09 16:55:49.803372600 -0700
@@ -15,7 +15,7 @@
 {
 
 /**
- * \ingroup wifi
+ * @ingroup wifi
  * Enumeration of the possible channel widths
  */
 enum class WifiChannelWidthType : uint8_t
@@ -34,7 +34,7 @@
 };
 
 /**
- * \ingroup wifi
+ * @ingroup wifi
  * The type of an MPDU.
  */
 enum MpduType
@@ -75,8 +75,8 @@
 };
 
 /**
- * \ingroup wifi
- * \brief Enumeration of frequency channel types
+ * @ingroup wifi
+ * @brief Enumeration of frequency channel types
  */
 enum class FrequencyChannelType : uint8_t
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/wifi-units.h ns-3.44/src/wifi/model/wifi-units.h
--- ns-3.43/src/wifi/model/wifi-units.h	2024-10-09 16:41:10.132656800 -0700
+++ ns-3.44/src/wifi/model/wifi-units.h	2025-03-09 16:55:49.803372600 -0700
@@ -13,8 +13,8 @@
 #include <cstdint>
 
 /**
- * \file
- * \ingroup wifi
+ * @file
+ * @ingroup wifi
  * Declaration of the SI units (as weak types aliases) used across wifi module
  */
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/wifi-utils.cc ns-3.44/src/wifi/model/wifi-utils.cc
--- ns-3.43/src/wifi/model/wifi-utils.cc	2024-10-09 16:41:10.132656800 -0700
+++ ns-3.44/src/wifi/model/wifi-utils.cc	2025-03-09 16:55:49.803372600 -0700
@@ -8,7 +8,9 @@
 
 #include "wifi-utils.h"
 
+#include "ap-wifi-mac.h"
 #include "ctrl-headers.h"
+#include "gcr-manager.h"
 #include "wifi-mac-header.h"
 #include "wifi-mac-trailer.h"
 
@@ -169,4 +171,30 @@
     return true;
 }
 
+bool
+IsGroupcast(const Mac48Address& adr)
+{
+    return adr.IsGroup() && !adr.IsBroadcast();
+}
+
+bool
+IsGcr(Ptr<WifiMac> mac, const WifiMacHeader& hdr)
+{
+    auto apMac = DynamicCast<ApWifiMac>(mac);
+    return apMac && apMac->UseGcr(hdr);
+}
+
+Mac48Address
+GetIndividuallyAddressedRecipient(Ptr<WifiMac> mac, const WifiMacHeader& hdr)
+{
+    const auto isGcr = IsGcr(mac, hdr);
+    const auto addr1 = hdr.GetAddr1();
+    if (!isGcr)
+    {
+        return addr1;
+    }
+    auto apMac = DynamicCast<ApWifiMac>(mac);
+    return apMac->GetGcrManager()->GetIndividuallyAddressedRecipient(addr1);
+}
+
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/wifi-utils.h ns-3.44/src/wifi/model/wifi-utils.h
--- ns-3.43/src/wifi/model/wifi-utils.h	2024-10-09 16:41:10.132656800 -0700
+++ ns-3.44/src/wifi/model/wifi-utils.h	2025-03-09 16:55:49.807372600 -0700
@@ -23,8 +23,10 @@
 namespace ns3
 {
 
+class Mac48Address;
 class WifiMacHeader;
 class Packet;
+class WifiMac;
 
 /**
  * Wifi direction. Values are those defined for the TID-to-Link Mapping Control Direction
@@ -38,11 +40,11 @@
 };
 
 /**
- * \brief Stream insertion operator.
+ * @brief Stream insertion operator.
  *
- * \param os the stream
- * \param direction the direction
- * \returns a reference to the stream
+ * @param os the stream
+ * @param direction the direction
+ * @returns a reference to the stream
  */
 inline std::ostream&
 operator<<(std::ostream& os, const WifiDirection& direction)
@@ -67,79 +69,137 @@
 /**
  * Convert from dBm to Watts.
  *
- * \param val the value in dBm
+ * @param val the value in dBm
  *
- * \return the equivalent Watts for the given dBm
+ * @return the equivalent Watts for the given dBm
  */
 Watt_u DbmToW(dBm_u val);
 /**
  * Convert from dB to ratio.
  *
- * \param val the value in dB
+ * @param val the value in dB
  *
- * \return ratio in linear scale
+ * @return ratio in linear scale
  */
 double DbToRatio(dB_u val);
 /**
  * Convert from Watts to dBm.
  *
- * \param val the value in Watts
+ * @param val the value in Watts
  *
- * \return the equivalent dBm for the given Watts
+ * @return the equivalent dBm for the given Watts
  */
 dBm_u WToDbm(Watt_u val);
 /**
  * Convert from ratio to dB.
  *
- * \param ratio the ratio in linear scale
+ * @param ratio the ratio in linear scale
  *
- * \return the value in dB
+ * @return the value in dB
  */
 dB_u RatioToDb(double ratio);
+
+/**
+ * Convert from MHz to Hz.
+ *
+ * @param val the value in MHz
+ *
+ * @return the value in Hz
+ */
+inline Hz_u
+MHzToHz(MHz_u val)
+{
+    return val * 1e6;
+}
+
+/**
+ * Convert from Hz to MHz.
+ *
+ * @param val the value in Hz
+ *
+ * @return the value in MHz
+ */
+inline MHz_u
+HzToMHz(Hz_u val)
+{
+    return val * 1e-6;
+}
+
+/**
+ * Return the number of 20 MHz subchannels covering the channel width.
+ *
+ * @param channelWidth the channel width
+ * @return the number of 20 MHz subchannels
+ */
+inline std::size_t
+Count20MHzSubchannels(MHz_u channelWidth)
+{
+    NS_ASSERT(static_cast<uint16_t>(channelWidth) % 20 == 0);
+    return channelWidth / MHz_u{20};
+}
+
+/**
+ * Return the number of 20 MHz subchannels covering the channel width between a lower frequency and
+ * an upper frequency. This function should only be called when the channel width between the lower
+ * frequency and the upper frequency is a multiple of 20 MHz.
+ *
+ * @param lower the lower frequency
+ * @param upper the upper frequency
+ * @return the number of 20 MHz subchannels
+ */
+inline std::size_t
+Count20MHzSubchannels(MHz_u lower, MHz_u upper)
+{
+    NS_ASSERT(upper >= lower);
+    const auto width = upper - lower;
+    NS_ASSERT((static_cast<uint16_t>(width) % 20 == 0));
+    return Count20MHzSubchannels(width);
+}
+
 /**
  * Return the total Ack size (including FCS trailer).
  *
- * \return the total Ack size in bytes
+ * @return the total Ack size in bytes
  */
 uint32_t GetAckSize();
 /**
  * Return the total BlockAck size (including FCS trailer).
  *
- * \param type the BlockAck type
- * \return the total BlockAck size in bytes
+ * @param type the BlockAck type
+ * @return the total BlockAck size in bytes
  */
 uint32_t GetBlockAckSize(BlockAckType type);
 /**
  * Return the total BlockAckRequest size (including FCS trailer).
  *
- * \param type the BlockAckRequest type
- * \return the total BlockAckRequest size in bytes
+ * @param type the BlockAckRequest type
+ * @return the total BlockAckRequest size in bytes
  */
 uint32_t GetBlockAckRequestSize(BlockAckReqType type);
 /**
  * Return the total MU-BAR size (including FCS trailer).
  *
- * \param types the list of Block Ack Request types of the individual BARs
- * \return the total MU-BAR size in bytes
+ * @param types the list of Block Ack Request types of the individual BARs
+ * @return the total MU-BAR size in bytes
  */
 uint32_t GetMuBarSize(std::list<BlockAckReqType> types);
 /**
  * Return the total RTS size (including FCS trailer).
  *
- * \return the total RTS size in bytes
+ * @return the total RTS size in bytes
  */
 uint32_t GetRtsSize();
 /**
  * Return the total CTS size (including FCS trailer).
  *
- * \return the total CTS size in bytes
+ * @return the total CTS size in bytes
  */
 uint32_t GetCtsSize();
 /**
- * \param seq MPDU sequence number
- * \param winstart sequence number window start
- * \param winsize the size of the sequence number window
- * \returns true if in the window
+ * @param seq MPDU sequence number
+ * @param winstart sequence number window start
+ * @param winsize the size of the sequence number window
+ * @returns true if in the window
  *
  * This method checks if the MPDU's sequence number is inside the scoreboard boundaries or not
  */
@@ -147,17 +207,17 @@
 /**
  * Add FCS trailer to a packet.
  *
- * \param packet the packet to add a trailer to
+ * @param packet the packet to add a trailer to
  */
 void AddWifiMacTrailer(Ptr<Packet> packet);
 /**
  * Return the total size of the packet after WifiMacHeader and FCS trailer
  * have been added.
  *
- * \param packet the packet to be encapsulated with WifiMacHeader and FCS trailer
- * \param hdr the WifiMacHeader
- * \param isAmpdu whether packet is part of an A-MPDU
- * \return the total packet size
+ * @param packet the packet to be encapsulated with WifiMacHeader and FCS trailer
+ * @param hdr the WifiMacHeader
+ * @param isAmpdu whether packet is part of an A-MPDU
+ * @return the total packet size
  */
 uint32_t GetSize(Ptr<const Packet> packet, const WifiMacHeader* hdr, bool isAmpdu);
 
@@ -165,13 +225,42 @@
  * Check if the given TID-to-Link Mappings are valid for a negotiation type of 1. Specifically,
  * it is checked whether all TIDs are mapped to the same set of links.
  *
- * \param dlLinkMapping the given TID-to-Link Mapping for Downlink
- * \param ulLinkMapping the given TID-to-Link Mapping for Uplink
- * \return whether the given TID-to-Link Mappings are valid for a negotiation type of 1
+ * @param dlLinkMapping the given TID-to-Link Mapping for Downlink
+ * @param ulLinkMapping the given TID-to-Link Mapping for Uplink
+ * @return whether the given TID-to-Link Mappings are valid for a negotiation type of 1
  */
 bool TidToLinkMappingValidForNegType1(const WifiTidLinkMapping& dlLinkMapping,
                                       const WifiTidLinkMapping& ulLinkMapping);
 
+/**
+ * Check whether a MAC destination address corresponds to a groupcast transmission.
+ *
+ * @param adr the MAC address
+ * @return true if the MAC address is a group address that is not a broadcast address
+ */
+bool IsGroupcast(const Mac48Address& adr);
+
+/**
+ * Return whether a given packet is transmitted using the GCR service.
+ *
+ * @param mac a pointer to the wifi MAC
+ * @param hdr the MAC header of the packet to check
+ * @return true if the packet is transmitted using the GCR service, false otherwise
+ */
+bool IsGcr(Ptr<WifiMac> mac, const WifiMacHeader& hdr);
+
+/**
+ * Get the MAC address of the individually addressed recipient to use for a given packet.
+ * If this is a groupcast packet to be transmitted with the GCR service, the GCR manager is
+ * requested to return which individually addressed recipient to use. Otherwise, it corresponds to
+ * the address1 of the MAC header.
+ *
+ * @param mac a pointer to the wifi MAC
+ * @param hdr the MAC header of the packet to check
+ * @return the MAC address of the individually addressed recipient to use
+ */
+Mac48Address GetIndividuallyAddressedRecipient(Ptr<WifiMac> mac, const WifiMacHeader& hdr);
+
 /// Size of the space of sequence numbers
 static constexpr uint16_t SEQNO_SPACE_SIZE = 4096;
 
@@ -185,6 +274,9 @@
 /// Invalid link identifier
 static constexpr uint8_t WIFI_LINKID_UNDEFINED = 0xff;
 
+/// Invalid TID identifier
+static constexpr uint8_t WIFI_TID_UNDEFINED = 0xff;
+
 /// Wi-Fi Time Unit value in microseconds (see IEEE 802.11-2020 sec. 3.1)
 /// Used to initialize WIFI_TU
 constexpr int WIFI_TU_US = 1024;
